#!/bin/bash

whoAmI=`whoami`
if [[ $whoAmI != "root" ]]
then
	echo
	echo "ERROR: Script must be run as root!"
	echo
	exit 99
fi

scriptDir=`dirname $0`

# "Fix" cookieless sessions by replacing the broken System.Web.dll with a patched version
SystemWebDest=`/usr/bin/find /usr/lib/mono/gac -name "System.Web.dll"`
MonoMajorVers=`/usr/bin/mono -V | grep version | awk '{print $5}' | awk -F. '{print $1"."$2}'`
if [[ $SystemWebDest != "" ]]
then
  if [[ -e "${scriptDir}/${MonoMajorVers}/System.Web.dll" ]]
  then
    if [[ ! -e "${SystemWebDest}.orig" ]]
    then
      echo
      echo "Backing up original unpatched System.Web.dll..."
      /bin/cp -p ${SystemWebDest} "${SystemWebDest}.orig"
    fi
    echo
    echo "Patching ${SystemWebDest}..."
    /bin/cp "${scriptDir}/${MonoMajorVers}/System.Web.dll" "${SystemWebDest}"
    echo
    echo "Patch complete.  Please restart Apache or Exago service to validate cookieless sessions functionality."
    echo
  else
    echo "WARNING: No compatible patched version of System.Web available for the current Mono installation."
    echo "         Cookieless sessions cannot be used with this install."
  fi
fi

